#!/usr/bin/perl

use lib "/usr/local/p2z/lib"; #use our own modules

use Palm::PDB;
use Palm::Datebook;
use Palm::Address;
use Palm::Memo;
use Palm::ToDo;
use Time::Local;
use Unicode::String qw(utf8 latin1);
use Data::Dumper;

#prepare some globals:
my %CATS;
   $CATS{'Unfiled'}=''; #All Categories with Unfiled-Category
my $UID = -1*time();
my $OUT = "/home/root";
my $OPIE= "/home/QtPalmtop/bin/opie-sh";

&intro(); #say hello

&findfiles("/home/root/Documents"); #find PDBs

&intro2();

if (-e $DATEBOOKLOC){
  my $DATEBOOK = new Palm::PDB;
     $DATEBOOK->Load($DATEBOOKLOC);
  &datebook($DATEBOOK);
}

if (-e $ADDRESSLOC){
  my $ADDRESS  = new Palm::PDB;
     $ADDRESS->Load($ADDRESSLOC);
  &address($ADDRESS);
}

if (-e $MEMOLOC){
  my $MEMO     = new Palm::PDB;
     $MEMO->Load($MEMOLOC);
  &memo($MEMO);
}

if (-e $TODOLOC){
  my $TODO     = new Palm::PDB;
     $TODO->Load($TODOLOC);
  &todo($TODO);
}


&saveZcats();

&outro();




sub memo($){
  my $PDB = $_[0];
     &createZcats($PDB);            #Catnames to Zaurus
  my @cats = &getCats($PDB);        #Catids to Name
  my @records = @{$PDB->{'records'}};
  my $count = 1;
  foreach my $rec (@records){
    mkdir("$OUT");
    mkdir("$OUT/Documents");
    mkdir("$OUT/Documents/text");
    mkdir("$OUT/Documents/text/plain");
    open(FILE,">$OUT/Documents/text/plain/memo$count.txt") || die("could not write");
    print FILE $rec->{'data'};
    close FILE;
    my $title = $rec->{'data'};
    $title =~ s/^\s*//s;
    $title =~ s/\n.*$//s;
    $title = &xe(substr($title,0,30));
    open(FILE,">$OUT/Documents/text/plain/memo$count.desktop") || die("could not write");
    print FILE "[Desktop Entry]\n";
    print FILE 'Categories = '.$CATS{$cats[$rec->{'category'}]}."\n";
    print FILE "File = $OUT/Documents/text/plain/memo$count.txt\n";
    print FILE 'Name = '.$title."\n";
    print FILE "Type = text/plain\n";
    close FILE;
    $count++;
  }
}

sub address($){
  my $PDB = $_[0];
     &createZcats($PDB);            #Catnames to Zaurus
  my @cats = &getCats($PDB);        #Catids to Name
  my %PBcat;                        #private or business cat
  my %cust;                         #custom2zfield
  my @records = @{$PDB->{'records'}};
  my @entries;
  my @zfields = qw(none FirstName MiddleName LastName JobTitle Department
                   Company BusinessPhone BusinessFax BusinessMobile
                   Emails HomePhone HomeFax HomeMobile BusinessStreet
                   BusinessCity BusinessState BusinessZip
                   BusinessCountry BusinessPager BusinessWebPage
                   HomeStreet HomeCity HomeState HomeZip HomeCountry
                   HomeWebPage Spouse Birthday Anniversary Nickname Notes);
  my $rid = 1;
  my $l;

  #How to handle Categories
  open (SHOW,"|$OPIE -f -t 'Category'");
  print SHOW <<end;
  <P>For converting your adressbook I'll need
  to ask you a few questions.</P>

  <P>Unlike the Palm-Addressbook on the
  Zaurus you can have two Addresses for
  a contact - one for business and one for
  private address. The usual way to handle
  this on a palm is to have private and
  business contacts separated by category.</P>

  <P>I now need to know how to handle your
  Palm-Categories: should the address
  converted to private or business one?</P>

  <P>Close this Window to continue...</P>
end
  close SHOW;
  foreach my $cat (@cats){
    my $key='';
    while ($key !~ /^[pPbB]$/){
#      print "How to handle \"$cat\"? [Private|Business] ";
#      ReadMode "raw";
#      $key = ReadKey 0, *STDIN;
#      ReadMode "normal";
#      print "$key\n";
      system(qq($OPIE -m -g -M 'How to handle "$cat"?' -t 'Category' -0 "Private" -1 "Business"));
      my $stat = $?/256;
      if($stat == 0){
        $key = 'p';
      }elsif($stat == 1){
        $key = 'b';
      }
    }
    $PBcat{$cat}=$key;
  }

  open (SHOW,"|$OPIE -f -t 'Custom'");
  print SHOW <<end;
  <P>The next thing I need to know is how to
  handle the custom fields in your
  addressbook.</P>

  <P>Please give the field I should use on
  the Zaurus. You may say 'none' to
  discard a field.</P>

  <P>Close this Window to continue...</P>
end
  close SHOW;
  for(my $i=1; $i<=4; $i++){
    my $field='';
    while (!&isin($field,@zfields)){
      my $choice = join("\n",@zfields);
      my $quest = '<P>Where should I "'.$PDB->{'appinfo'}{'fieldLabels'}{"custom$i"}.'" put into?</P>';
      $field = `echo '$choice'|$OPIE -i -l -g -L '$quest' -t 'Custom'`;
      chomp($field);
    }
    $cust{"custom$i"}=$field;
  }

  my ($i,$pre,$note,$work,$home,$fax,$mail,$pager,$mobile);
  foreach my $rec (@records){
    $l = '';
    $work   ='';
    $home   ='';
    $fax    ='';
    $mail   ='';
    $pager  ='';
    $mobile ='';
    $note   ='';

    $l .= '<Contact ';
    $l .= 'FirstName="'.&xe($rec->{'fields'}{'firstName'}).'" ';
    $l .= 'LastName="'.&xe($rec->{'fields'}{'name'}).'" ';
    $l .= 'FileAs="'.&xe($rec->{'fields'}{'name'}).', '.&xe($rec->{'fields'}{'firstName'}).'" ';
    $l .= 'Company="'.&xe($rec->{'fields'}{'company'}).'" ';
    $l .= 'JobTitle="'.&xe($rec->{'fields'}{'title'}).'" ';

    $pre = 'Home';
    $pre = 'Business' if ($PBcat{$cats[$rec->{'category'}]} =~ /^[bB]$/);

    $l .= $pre.'Street="'.&xe($rec->{'fields'}{'address'}).'" ';
    $l .= $pre.'City="'.&xe($rec->{'fields'}{'city'}).'" ';
    $l .= $pre.'State="'.&xe($rec->{'fields'}{'state'}).'" ';
    $l .= $pre.'Zip="'.&xe($rec->{'fields'}{'zipCode'}).'" ';

    #phones
    for($i=1; $i<=5; $i++){
      next if ($rec->{'fields'}{"phone$i"} eq '');
      if ($rec->{'phoneLabel'}{"phone$i"} == 0){
        $work .= &xe($rec->{'fields'}{"phone$i"}).', ';
      }elsif($rec->{'phoneLabel'}{"phone$i"} == 1){
        $home .= &xe($rec->{'fields'}{"phone$i"}).', ';
      }elsif($rec->{'phoneLabel'}{"phone$i"} == 2){
        $fax .= &xe($rec->{'fields'}{"phone$i"}).', ';
      }elsif($rec->{'phoneLabel'}{"phone$i"} == 3){
        $note .= &xe($rec->{'fields'}{"phone$i"})."\n";
      }elsif($rec->{'phoneLabel'}{"phone$i"} == 4){
        $mail .= &xe($rec->{'fields'}{"phone$i"}).', ';
      }elsif($rec->{'phoneLabel'}{"phone$i"} == 5){
        $work .= &xe($rec->{'fields'}{"phone$i"}).', ';
      }elsif($rec->{'phoneLabel'}{"phone$i"} == 6){
        $pager .= &xe($rec->{'fields'}{"phone$i"}).', ';
      }elsif($rec->{'phoneLabel'}{"phone$i"} == 7){
        $mobile .= &xe($rec->{'fields'}{"phone$i"}).', ';
      }
    }
    $work   =~ s/, $//;
    $home   =~ s/, $//;
    $fax    =~ s/, $//;
    $mail   =~ s/, $//;
    $pager  =~ s/, $//;
    $mobile =~ s/, $//;
    $l .= 'BusinessPhone="'.$work.'" ';
    $l .= 'HomePhone="'.$home.'" ';
    $l .= $pre.'Fax="'.$fax.'" ';
    $l .= 'Emails="'.$mail.'" ';
    $l .= 'BusinessPager="'.$pager.'" ';
    $l .= $pre.'Mobile="'.$mobile.'" ';

    #custom fields
    for($i=1; $i<=4; $i++){ 
      next if ($cust{"custom$i"} eq 'none');
      if ($cust{"custom$i"} eq 'Notes'){
        $note .= &xe($PDB->{'appinfo'}{'fieldLabels'}{"custom$i"}).": ";
        $note .= &xe($rec->{'fields'}{"custom$i"})."\n";
      }else{
        $l .= $cust{"custom$i"}.'="'.&xe($rec->{'fields'}{"custom$i"}).'" ';
      }
    }
    $note .=&xe($rec->{'fields'}{'note'});
    $l .= 'Notes="'.$note.'" ';
    $l .= 'Categories="'.$CATS{$cats[$rec->{'category'}]}.'" ';
    $l .= 'uid="'.($UID--).'" ';
    $l .= 'rid="'.($rid++).'" ';
    $l .= 'rinfo="1" '; #what's this good for?
    $l .= "/>\n";
    push(@entries,"  $l");
  }
  #xml-preamble
  unshift(@entries,"<Contacts>\n");
  unshift(@entries,"<Groups></Groups>\n");
  unshift(@entries,"<RIDMax>$rid</RIDMax>\n");
  unshift(@entries,"<AddressBook>\n");
  unshift(@entries,"<!DOCTYPE Addressbook >\n");
  unshift(@entries,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
  #xml-postamble
  push(@entries,"</Contacts>\n");
  push(@entries,"</AddressBook>");
  #write output
  mkdir("$OUT");
  mkdir("$OUT/Applications");
  mkdir("$OUT/Applications/addressbook");
  open(FILE,">$OUT/Applications/addressbook/addressbook.xml") || die("could not write");
  print FILE @entries;
  close FILE;
}

sub todo($){
  my $PDB = $_[0];
     &createZcats($PDB);            #Catnames to Zaurus
  my @cats = &getCats($PDB);        #Catids to Name
  my @records = @{$PDB->{'records'}};
  my @entries;
  my $l;
  foreach my $rec (@records){
    $l = '';
    $l .= '<Task ';
    if ($rec->{'completed'}){
      $l .= 'Completed="1" ';
    }else{
      $l .= 'Completed="0" ';
    }
    if (defined($rec->{'due_day'})){
      $l .= 'HasDate="1" ';
    }else{
      $l .= 'HasDate="0" ';
    }
    $l .= 'Priority="'.$rec->{'priority'}.'" ';
    $l .= 'Categories="'.$CATS{$cats[$rec->{'category'}]}.'" ';
    $l .= 'Description="'.&xe(join("\n\n",$rec->{'description'},$rec->{'note'})).'" ';
    if (defined($rec->{'due_day'})){
      $l .= 'DateYear="'.$rec->{'due_year'}.'" ';
      $l .= 'DateMonth="'.$rec->{'due_month'}.'" ';
      $l .= 'DateDay="'.$rec->{'due_day'}.'" ';
    }
    $l .= 'Uid="'.$UID--.'" ';
    $l .= "/>\n";
    push(@entries,$l);
  }
  #xml-preamble
  unshift(@entries,"<Tasks>\n");
  unshift(@entries,"<!DOCTYPE Tasks>\n");
  unshift(@entries,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
  #xml-postamble
  push(@entries,"</Tasks>\n");
  #write output
  mkdir("$OUT");
  mkdir("$OUT/Applications");
  mkdir("$OUT/Applications/todolist");
  open(FILE,">$OUT/Applications/todolist/todolist.xml") || die("could not write");
  print FILE @entries;
  close FILE;
}

sub datebook($){
  my $PDB = $_[0];
     &createZcats($PDB);            #Catnames to Zaurus
  my @cats = &getCats($PDB);        #Catids to Name
  my @records = @{$PDB->{'records'}};
  my @entries;
  my $rid = 1;
  my $l;
  foreach my $rec (@records){
    $l = '';
    $l .= '<event ';
    $l .= 'description="'.&xe($rec->{'description'}).'" ';
    $l .= 'location="(unknown)" ';
    $l .= 'categories="'.$CATS{$cats[$rec->{'category'}]}.'" ';
    $l .= 'uid="'.($UID--).'" ';
    #nontimed event:
    $l .= 'type="AllDay" ' if ($rec->{'start_hour'} == 0xff);
    #Alarm
    if (defined($rec->{'alarm'})){
      my $m = 1;
         $m = 60   if ($rec->{'alarm'}{'unit'} == 1);
         $m = 3600 if ($rec->{'alarm'}{'unit'} == 2);
      $l .= 'alarm="'.($rec->{'alarm'}{'advance'} * $m).'" ';
      $l .= 'sound="loud" ';
    }
    #repeatinfo
    if(defined($rec->{'repeat'})){
      if($rec->{'repeat'}{'type'} == 1){     #daily
        $l .= 'rtype="Daily" ';
      }elsif($rec->{'repeat'}{'type'} == 2){ #weekly
        $l .= 'rtype="Weekly" ';
        #rearrange dayorder:
        push(@{$rec->{'repeat'}{'repeat_days'}},shift(@{$rec->{'repeat'}{'repeat_days'}}));        
        my $days=0;
        for (my $i=0; $i<7; $i++){ #calculate days 
          $days = $days + ($rec->{'repeat'}{'repeat_days'}[$i])*(2**$i);
        }
        $l .= 'rweekdays="'.$days.'" ';
      }elsif($rec->{'repeat'}{'type'} == 3){ #monthly by day
        $l .= 'rtype="MonthlyDay" ';
        $l .= 'rposition="'.$rec->{'repeat'}{'weeknum'}.'" ';
      }elsif($rec->{'repeat'}{'type'} == 4){ #monthly by date
        $l .= 'rtype="MonthlyDate" ';
        $l .= 'rposition="'.$rec->{'repeat'}{'weeknum'}.'" ';
      }elsif($rec->{'repeat'}{'type'} == 5){ #yearly
        $l .= 'rtype="Yearly" ';
      }    
      $l .= 'rfreq="'.$rec->{'repeat'}{'frequency'}.'" ';
      if(defined($rec->{'repeat'}{'end_day'})){
        $l .= 'rhasenddate="1" ';
        $l .= 'enddt="'.timelocal(0,0,0,
                                  $rec->{'repeat'}{'end_day'},
                                  $rec->{'repeat'}{'end_month'}-1,
                                  $rec->{'repeat'}{'end_year'}-1900).'" ';
      }else{
        $l .= 'rhasenddate="0" ';
      }
    }

    $l .= 'created="'.time().'" '; 
    #timeinfos:
    if ($rec->{'start_hour'} == 0xff){
      $l .= 'start="'.timelocal(0,0,0,
                                $rec->{'day'},
                                $rec->{'month'}-1,
                                $rec->{'year'}-1900).'" ';
      $l .= 'end="'.  timelocal(0,59,23,
                                $rec->{'day'},
                                $rec->{'month'}-1,
                                $rec->{'year'}-1900).'" ';
    }else{
      $l .= 'start="'.timelocal(0,
                                $rec->{'start_minute'},
                                $rec->{'start_hour'},
                                $rec->{'day'},
                                $rec->{'month'}-1,
                                $rec->{'year'}-1900).'" ';
      $l .= 'end="'.  timelocal(0,
                                $rec->{'end_minute'},
                                $rec->{'end_hour'},
                                $rec->{'day'},
                                $rec->{'month'}-1,
                                $rec->{'year'}-1900).'" ';
    }
    $l .= 'note="'.&xe($rec->{'note'}).'" ';
    $l .= "/>\n";
    push(@entries,$l);
  }
  #xml-preamble
  unshift(@entries,"<events>\n");
  unshift(@entries,"<DATEBOOK>\n");
  unshift(@entries,"<!DOCTYPE DATEBOOK >");
  unshift(@entries,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
  #xml-postamble
  push(@entries,"</events>\n");
  push(@entries,"</DATEBOOK>");
  #write output
  mkdir("$OUT");
  mkdir("$OUT/Applications");
  mkdir("$OUT/Applications/datebook");
  open(FILE,">$OUT/Applications/datebook/datebook.xml") || die("could not write");
  print FILE @entries;
  close FILE;
}


sub saveZcats(){
  #write output
  mkdir("$OUT");
  mkdir("$OUT/Settings");
  open(FILE,">$OUT/Settings/Categories.xml");
  print FILE "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
  print FILE "<!DOCTYPE CategoryList>\n";
  print FILE "<Categories>\n";
  while (my($name,$id)=each(%CATS)){
    next if ($id eq '');
    print FILE '<Category id="'.$id.'" name="'.&xe($name)."\" />\n";
  }
  print FILE "</Categories>\n";
  close FILE;
}

sub createZcats($){
  my $PDB = $_[0];
  my @cats = @{$PDB->{'appinfo'}{'categories'}};
  #Read Categories from PDB:
  foreach my $cat (@cats){
    next if ($cat->{'name'} eq ''); #Skip empty cats
    next if ($cat->{'id'} == 0);    #Skip unfiled
    if (!defined($CATS{$cat->{'name'}})){
      $CATS{$cat->{'name'}} = $UID--; #Create UniqueID (negative timestamp)
    }
  }
}

sub getCats($){
  my $PDB = $_[0];
  my @cats = @{$PDB->{'appinfo'}{'categories'}};
  my @c;
     $c[0] = 'Unfiled';
  for (my $i=1; $i<scalar(@cats); $i++){
    next if($cats[$i]->{'name'} eq '');
    $c[$i] = $cats[$i]->{'name'};
  }
  return @c;
}

sub xe($){
  my $string = latin1($_[0]);
  $string =~ s/&/&amp;/sg;
  $string =~ s/</&lt;/sg;
  $string =~ s/>/&rt;/sg;
  $string =~ s/"/&quot;/sg;
  $string =~ s/'/&apos;/sg;
  return $string;
}

sub isin($@){
  my $needle = shift;
  chomp($needle);
  my @haystack = @_;
  foreach my $row (@haystack){
    return 1 if ($needle eq $row);
  }
  return 0;
}

sub findfiles($){
  my $path=$_[0];

  opendir(ROOT, $path);
  my @files = readdir(ROOT);
  closedir(ROOT);

  foreach my $file (@files) {
    next if ($file =~ /^\./);    #skip upper dirs and hidden files
    my $fullFilename = "$path/$file";

    if (-d $fullFilename) {
      &findfiles($fullFilename); #Recursion
      next;
    }

    if ($file =~ /^AddressDB\.(pdb|prc)$/i){
      $ADDRESSLOC = $fullFilename;
      next;
    }
    if ($file =~ /^DatebookDB\.(pdb|prc)$/i){
      $DATEBOOKLOC = $fullFilename;
      next;
    }
    if ($file =~ /^MemoDB\.(pdb|prc)$/i){
      $MEMOLOC = $fullFilename;
      next;
    }
    if ($file =~ /^ToDoDB\.(pdb|prc)$/i){
      $TODOLOC = $fullFilename;
      next;
    }
  }
}

sub intro(){
  open (SHOW,"|$OPIE -f -t 'P2Z'");
  print SHOW <<end;
  <H1>P2Z</H1>

  <P><B>Welcome to the Palm2Zaurus PIM
  conversion software!</B></P>

  <P>This Software converts your
  Adressbook-, Datebook-, ToDo-
  and Memo-Data from your Palm
  powered Organizer (tm) to the
  Zaurus builtin PIM-Application
  format.</P>

  <P>To run it you must copy the
  following files from your Palm
  to the Document-Tab:</P>

  AddressDB.pdb<BR>
  DatebookDB.pdb<BR>
  MemoDB.pdb<BR>
  ToDoDB.pdb<BR>

  <P>Be sure to read the README at
  http://www.mobilix.org/p2z/ !</P>

  <P>Close this Window to continue...</P>
  <HR>
  <P>This is free software! (GPL)<BR>
  see COPYING for more info!</P>
end
  close SHOW;
}

sub intro2(){
  open (SHOW,"|$OPIE -f -t 'P2Z'");
  print SHOW <<end;
  <H2>Some Warnings...</H2>

  <P>P2Z will <B>close all
  Zaurus PIM Applications</B> (Calendar, Addressbook,
  ToDo-List, Texteditor) to avoid problems.</P>

  <P>P2Z <B>overwrites your existing Zaurus Data</B>!
  So you should run it only on a new Zaurus</P>

  <P>P2Z does not support incremental conversions,
  which means you should <B>always convert all four
  datafiles</B> at once. Rerunning this tool will
  overwrite previous category data.</P>

  <P>The following files were found:<BR>
  $ADDRESSLOC<BR>
  $DATEBOOKLOC<BR>
  $MEMOLOC<BR>
  $TODOLOC<BR>
  </P>

  <P>The Zaurus hasn't a Gigahertz
  processor! So <B>be patient</B> while conversion!</P>

  <P>Close this Window to continue...<BR>
  (You will be asked if you want to continue)</P>
end
  close SHOW;

  unless((-e $ADDRESSLOC)  ||
         (-e $DATEBOOKLOC) ||
         (-e $MEMOLOC)     ||
         (-e $TODOLOC)       ){
    system(qq($OPIE -m -g -e -t 'No files' -M '<P>No Palm-Files where found<BR>P2Z can not continue</P>'));
    exit;
  }
  system(qq($OPIE -m -g -t 'Continue?' -M 'Continue?' -0 'No - Exit' -1 'Yes - Continue'));
  my $stat = $?/256;
  unless($stat == 1){
    exit;
  }

  system ('killall addressbook');
  system ('killall datebook');
  system ('killall todolist');
  system ('killall textedit');
}

sub outro(){
  open (SHOW,"|$OPIE -f -t 'P2Z'");
  print SHOW <<end;
  <H1>Thanks!</H1>

  <P>Thank you for using this tool!<BR>
  Please send comments, bugs and ideas to
  a.gohr\@web.de</P>

  <P>You may now delete this package,
  it's dependencies (perl and opie-sh) and
  your Palm-PDBs.</P>

  <P>The development of this tool was sponsored by
  XTops.DE - Laptops+PDAs pre-installed with UniX
  (http://www.xtops.de)</P>

  <P>Close this Window to exit...</P>
end
  close SHOW;
}
